// $ANTLR 2.7.7 (20060906): "asn1.g" -> "ASNParser.java"$

package org.openmuc.jasn1.compiler.parser;

import org.openmuc.jasn1.compiler.model.*;
import java.math.*;
import java.util.*;

public interface ASNTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int ABSENT_KW = 4;
	int ALL_KW = 5;
	int ANY_KW = 6;
	int ARGUMENT_KW = 7;
	int APPLICATION_KW = 8;
	int AUTOMATIC_KW = 9;
	int BASED_NUM_KW = 10;
	int BEGIN_KW = 11;
	int BIT_KW = 12;
	int BMP_STR_KW = 13;
	int BOOLEAN_KW = 14;
	int BY_KW = 15;
	int CHARACTER_KW = 16;
	int CHOICE_KW = 17;
	int CLASS_KW = 18;
	int COMPONENTS_KW = 19;
	int COMPONENT_KW = 20;
	int CONSTRAINED_KW = 21;
	int DEFAULT_KW = 22;
	int DEFINED_KW = 23;
	int DEFINITIONS_KW = 24;
	int EMBEDDED_KW = 25;
	int END_KW = 26;
	int ENUMERATED_KW = 27;
	int ERROR_KW = 28;
	int ERRORS_KW = 29;
	int EXCEPT_KW = 30;
	int EXPLICIT_KW = 31;
	int EXPORTS_KW = 32;
	int EXTENSIBILITY_KW = 33;
	int EXTERNAL_KW = 34;
	int FALSE_KW = 35;
	int FROM_KW = 36;
	int GENERALIZED_TIME_KW = 37;
	int GENERAL_STR_KW = 38;
	int GRAPHIC_STR_KW = 39;
	int IA5_STRING_KW = 40;
	int IDENTIFIER_KW = 41;
	int IMPLICIT_KW = 42;
	int IMPLIED_KW = 43;
	int IMPORTS_KW = 44;
	int INCLUDES_KW = 45;
	int INSTANCE_KW = 46;
	int INTEGER_KW = 47;
	int INTERSECTION_KW = 48;
	int ISO646_STR_KW = 49;
	int LINKED_KW = 50;
	int MAX_KW = 51;
	int MINUS_INFINITY_KW = 52;
	int MIN_KW = 53;
	int NULL_KW = 54;
	int NUMERIC_STR_KW = 55;
	int OBJECT_DESCRIPTOR_KW = 56;
	int OBJECT_KW = 57;
	int OCTET_KW = 58;
	int OPERATION_KW = 59;
	int OF_KW = 60;
	int OID_KW = 61;
	int OPTIONAL_KW = 62;
	int PARAMETER_KW = 63;
	int PDV_KW = 64;
	int PLUS_INFINITY_KW = 65;
	int PRESENT_KW = 66;
	int PRINTABLE_STR_KW = 67;
	int PRIVATE_KW = 68;
	int REAL_KW = 69;
	int RELATIVE_KW = 70;
	int RESULT_KW = 71;
	int SEQUENCE_KW = 72;
	int SET_KW = 73;
	int SIZE_KW = 74;
	int STRING_KW = 75;
	int SYNTAX_KW = 76;
	int TAGS_KW = 77;
	int TELETEX_STR_KW = 78;
	int TRUE_KW = 79;
	int T61_STR_KW = 80;
	int UNION_KW = 81;
	int UNIQUE_KW = 82;
	int UNIVERSAL_KW = 83;
	int UNIVERSAL_STR_KW = 84;
	int UTC_TIME_KW = 85;
	int UTF8_STR_KW = 86;
	int VIDEOTEX_STR_KW = 87;
	int VISIBLE_STR_KW = 88;
	int WITH_KW = 89;
	int TIME_KW = 90;
	int DATE_KW = 91;
	int TIME_OF_DAY_KW = 92;
	int DATE_TIME_KW = 93;
	int DURATION_KW = 94;
	int ASSIGN_OP = 95;
	int BAR = 96;
	int COLON = 97;
	int COMMA = 98;
	int COMMENT = 99;
	int DOT = 100;
	int AMPERSAND = 101;
	int DOTDOT = 102;
	int ELLIPSIS = 103;
	int EXCLAMATION = 104;
	int INTERSECTION = 105;
	int LESS = 106;
	int L_BRACE = 107;
	int L_BRACKET = 108;
	int L_PAREN = 109;
	int MINUS = 110;
	int PLUS = 111;
	int R_BRACE = 112;
	int R_BRACKET = 113;
	int R_PAREN = 114;
	int SEMI = 115;
	int SINGLE_QUOTE = 116;
	int CHARB = 117;
	int CHARH = 118;
	int AT_SIGN = 119;
	int WS = 120;
	int SL_COMMENT = 121;
	int ML_COMMENT = 122;
	int NUMBER = 123;
	int UPPER = 124;
	int LOWER = 125;
	int BDIG = 126;
	int HDIG = 127;
	int B_OR_H_STRING = 128;
	int B_STRING = 129;
	int H_STRING = 130;
	int C_STRING = 131;
	int LITERAL_BIND = 132;
	int LITERAL_UNBIND = 133;
	// "APPLICATION-SERVICE-ELEMENT" = 134
	// "APPLICATION-CONTEXT" = 135
	int LITERAL_EXTENSION = 136;
	int LITERAL_EXTENSIONS = 137;
	// "EXTENSION-ATTRIBUTE" = 138
	int LITERAL_TOKEN = 139;
	// "TOKEN-DATA" = 140
	// "SECURITY-CATEGORY" = 141
	int LITERAL_PORT = 142;
	int LITERAL_REFINE = 143;
	// "ABSTRACT-BIND" = 144
	// "ABSTRACT-UNBIND" = 145
	// "ABSTRACT-OPERATION" = 146
	// "ABSTRACT-ERROR" = 147
	int LITERAL_ALGORITHM = 148;
	int LITERAL_ENCRYPTED = 149;
	int LITERAL_SIGNED = 150;
	int LITERAL_SIGNATURE = 151;
	int LITERAL_PROTECTED = 152;
	// "OBJECT-TYPE" = 153
	int EXCEPT = 154;
	int INCLUDES = 155;
	int PATTERN_KW = 156;
}
