/**
 * This class file was automatically generated by jASN1 v1.8.0 (http://www.openmuc.org)
 */

package org.openmuc.jasn1.compiler.pkix1explicit88;

import java.io.IOException;
import java.io.EOFException;
import java.io.InputStream;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.io.Serializable;
import org.openmuc.jasn1.ber.*;
import org.openmuc.jasn1.ber.types.*;
import org.openmuc.jasn1.ber.types.string.*;


public class PostalCode implements Serializable {

	private static final long serialVersionUID = 1L;

	public byte[] code = null;
	public BerNumericString numericCode = null;
	public BerPrintableString printableCode = null;
	
	public PostalCode() {
	}

	public PostalCode(byte[] code) {
		this.code = code;
	}

	public PostalCode(BerNumericString numericCode, BerPrintableString printableCode) {
		this.numericCode = numericCode;
		this.printableCode = printableCode;
	}

	public int encode(BerByteArrayOutputStream os) throws IOException {

		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				os.write(code[i]);
			}
			return code.length;
		}

		int codeLength = 0;
		if (printableCode != null) {
			codeLength += printableCode.encode(os, true);
			return codeLength;
		}
		
		if (numericCode != null) {
			codeLength += numericCode.encode(os, true);
			return codeLength;
		}
		
		throw new IOException("Error encoding CHOICE: No element of CHOICE was selected.");
	}

	public int decode(InputStream is) throws IOException {
		return decode(is, null);
	}

	public int decode(InputStream is, BerTag berTag) throws IOException {

		int codeLength = 0;
		BerTag passedTag = berTag;

		if (berTag == null) {
			berTag = new BerTag();
			codeLength += berTag.decode(is);
		}

		if (berTag.equals(BerNumericString.tag)) {
			numericCode = new BerNumericString();
			codeLength += numericCode.decode(is, false);
			return codeLength;
		}

		if (berTag.equals(BerPrintableString.tag)) {
			printableCode = new BerPrintableString();
			codeLength += printableCode.decode(is, false);
			return codeLength;
		}

		if (passedTag != null) {
			return 0;
		}

		throw new IOException("Error decoding CHOICE: Tag " + berTag + " matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		BerByteArrayOutputStream os = new BerByteArrayOutputStream(encodingSizeGuess);
		encode(os);
		code = os.getArray();
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		appendAsString(sb, 0);
		return sb.toString();
	}

	public void appendAsString(StringBuilder sb, int indentLevel) {

		if (numericCode != null) {
			sb.append("numericCode: ").append(numericCode);
			return;
		}

		if (printableCode != null) {
			sb.append("printableCode: ").append(printableCode);
			return;
		}

		sb.append("<none>");
	}

}

